import java.io.*;
import java.util.*;

public class Main {
    public static class Point{
        long y;
        long z;
        public Point(long y , long z){
            this.y = y;
            this.z = z;
        }
    }
    static class TheComparator implements Comparator<Point>{
        @Override
        public int compare(Point o1 , Point o2){
            return Long.compare(o1.y , o2.y);
        }
    }
    public static void main(String[] args) throws IOException {
        int a = nextInt();
        long x = nextLong();
        long b [] = new long[a];
        long c [] = new long[a];
        for (int i = 0; i < a; i++) {
            b[i] = nextLong();
        }
        for (int i = 0; i < a; i++) {
            c[i] = nextLong();
        }
        long ans = 0;
        long cnt=  1;
        long sum=  0;
        while (sum < x){
            for (int i = 0; i < a; i++) {
                if(b[i] == cnt){
                    sum++;
                }
                if(c[i] + b[i] == cnt){
                    ans++;
                    sum--;
                }
            }
            if(ans > 0){
                sum += ans * 2;
                ans *= 2;
            }
            cnt++;
        }
        if(sum == x) {
            out.println(cnt - 1);
        }
        else{
            out.println(-1);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}